﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;


namespace ThExBatch
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] vrstica;
            uint[,] frame = new uint[288, 384];
            int ln = 0;
            uint val = 0;
            uint v = 0;
            uint minValue = 60000;
            uint maxValue = 0;
            Bitmap bmp = new Bitmap(384, 288);
            Bitmap paletteImg = new Bitmap("Iron.png");

            string currentDir = Directory.GetCurrentDirectory();
            DirectoryInfo dinfo = new DirectoryInfo(currentDir);
            FileInfo[] Files = dinfo.GetFiles("*.csv");

            foreach (FileInfo file in Files)
            {
                v = 0;
                val = 0;
                minValue = 60000;
                maxValue = 0;
                ln = 0;
                Array.Clear(frame, 0, frame.Length);

                foreach (string line in File.ReadLines(file.Name.ToString(), Encoding.Default))
                {
                    if (ln > 288 && ln < 576)
                    {
                        vrstica = line.Split(',');
                        for (int i = 0; i < vrstica.Length - 1; i++)
                        {
                            val = uint.Parse(vrstica[i]);
                            frame[ln - 289, i] = val;
                        }
                    }
                    ln++;
                }

                for (int y = 0; y < 288; y++)
                {
                    for (int x = 0; x < 384; x++)
                    {
                        val = frame[y, x];
                        if (val > maxValue)
                        {
                            maxValue = val;
                        }
                        if (val < minValue)
                        {
                            minValue = val;
                        }
                    }
                }

                for (int y = 0; y < 288; y++)
                {
                    for (int x = 0; x < 384; x++)
                    {
                        v = frame[y, x];
                        uint maxmin = maxValue;
                        maxmin -= minValue;
                        if (maxmin == 0)
                            maxmin = 1;

                        v = (v - minValue) * 999 / maxmin;
                        if (v < 0)
                            v = 0;
                        if (v > 999)
                            v = 999;

                        bmp.SetPixel(x, y, paletteImg.GetPixel((int)v, 0));
                    }
                }
                FileInfo fileDest = new FileInfo(currentDir + @"\export\te_" + file.Name.Replace(".csv", "") + ".png");
                fileDest.Directory.Create();
                bmp.Save(fileDest.FullName);
            }
            Console.WriteLine("Done!");
            //Console.ReadKey();
        }
    }
}
